import os, glob, csv

#=====================================================================
# Open CSV database of the manual to get the 15 categories

fname = "ConTeXt_Garden_manuals_database_20200523.csv"
file = open(fname, "r")
reader = csv.reader(file,delimiter = ';')

Category = []
next(reader)
for row in reader:
    row[0] 
    if row[0][4:] not in Category:
        Category.append(row[0][4:])
file.close()

#=====================================================================
# For each category, find manually one wiki page as "central page"

Liens_Wiki= [
[1,"ManualsGallery"],
[2,"Fonts"],
[3,"Colors"],
[4,"Graphics"],
[5,"Layout"],
[6,"Tables_Overview"],
[7,"Bibliography_mkiv"],
[8,"Sciences"],
[9,"Interaction"],
[10,"Languages"],
[11,"Template:Main_Page/Tips_and_Tricks"],
[12,"XML"],
[13,"Programming_in_LuaTeX"],
[14,"Template:Main_Page/Development"],
[15,"Text_Editors"]]

#=====================================================================
# Start writing mediawiki syntaxe for a Welcome Screen

fout = open("ConTeXt_Garden_wiki_MainPage_output.txt", "w")

# Introduction text

fout.write("=== <div style=\"text-align: center;\">"+
           "ConTeXt Garden, Documentation, Manuals, " +
           "Tip and Tricks, Discussions, are mostly organized "+
           "according to these 15 topics"+
           "</div> ===\n")

# thumbnails width (2 boxes in smartphone portrait, 3 in landscape)
ew="130px"

# start itemize with a responsive design "display: grid"

fout.write("<ul style=\""+
           "display: grid; " +
           "grid-template-columns: repeat(auto-fit, "+ew+"); " +
           "grid-gap: 15px; " +
           "justify-content: space-between; " +
           "list-style: none; " +
           "padding: 1rem; " +
           "margin: 0;"+
           "\">\n")

# One category ==> one item

kj=0
for j in Category:

    fout.write("<li style=\""+
               "text-align:center; "+
               "background-color: #A7A3A0; "+
               "box-shadow: 0px 8px 8px gray;"+
               "\">\n")

    # write the category as a level 4 title

    fout.write("==== <div style=\"height: 2.5em; "+
               "vertical-align: bottom; "+
               "color: white;\">" +
               j +
               "</div> ====\n")

    # add links (Manuals, categ's Central Page° + logo
    # required work to match mediawiki name conventions

    fout.write("[[ManualsGallery#"+
               j.replace(" ","_").replace(",",".2C")+
               "|Manuals]]"+
               #
               "&nbsp;|&nbsp;"+
               #
               "[["+Liens_Wiki[kj][1]+"|Wiki]]</br>\n"+
               "[[File:logo_"+
               j.replace(" ", "_").replace(",","")+".png|"+ew+
               "|link="+Liens_Wiki[kj][1]+"]]")

    fout.write("</li>\n")
    kj=kj+1;

# stop itemize and adds vertical space

fout.write("</ul></br>\n")
fout.close()

